scala.collection

# Iterator

#### object Iterator

The `Iterator` object provides various functions for creating specialized iterators.

Source
  Iterator.scala
Version

  2.8

Since

  2.8

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Iterator
2. AnyRef
3. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### implicit def IteratorCanBuildFrom[A]: BufferedCanBuildFrom[A, Iterator]

   With the advent of `TraversableOnce` and `Iterator`, it can be useful to have a builder which operates on `Iterator`s so they can be treated uniformly along with the collections.

   With the advent of `TraversableOnce` and `Iterator`, it can be useful to have a builder which operates on `Iterator`s so they can be treated uniformly along with the collections. See `scala.util.Random.shuffle` for an example.

7. #### def apply[A](elems: A*): Iterator[A]

   Creates an iterator with given elements.

   Creates an iterator with given elements.

   elems

     The elements returned one-by-one from the iterator

   returns

     An iterator which produces the given elements on the first calls to `next`, and which has no further elements.

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws ()
   Note

     not specified by SLS as a member of AnyRef

10. #### def continually[A](elem: ⇒ A): Iterator[A]

    Creates an infinite-length iterator returning the results of evaluating an expression.

    Creates an infinite-length iterator returning the results of evaluating an expression. The expression is recomputed for every element.

    elem

      the element computation.

    returns

      the iterator containing an infinite number of results of evaluating `elem`.

11. #### val empty: Iterator[Nothing]

    The iterator which produces no values.

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def fill[A](len: Int)(elem: ⇒ A): Iterator[A]

    Creates iterator that produces the results of some element computation a number of times.

    Creates iterator that produces the results of some element computation a number of times.

    len

      the number of elements returned by the iterator.

    elem

      the element computation

    returns

      An iterator that produces the results of `n` evaluations of `elem`.

15. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ()
    Note

      not specified by SLS as a member of AnyRef

16. #### def from(start: Int, step: Int): Iterator[Int]

    Creates an infinite-length iterator returning values equally spaced apart.

    Creates an infinite-length iterator returning values equally spaced apart.

    start

      the start value of the iterator

    step

      the increment between successive values

    returns

      the iterator producing the infinite sequence of values `start, start + 1 * step, start + 2 * step, ...`

17. #### def from(start: Int): Iterator[Int]

    Creates an infinite-length iterator which returns successive values from some start value.

    Creates an infinite-length iterator which returns successive values from some start value.

    start

      the start value of the iterator

    returns

      the iterator producing the infinite sequence of values `start, start + 1, start + 2, ...`

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

20. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

21. #### def iterate[T](start: T)(f: (T) ⇒ T): Iterator[T]

    Creates an infinite iterator that repeatedly applies a given function to the previous result.

    Creates an infinite iterator that repeatedly applies a given function to the previous result.

    start

      the start value of the iterator

    f

      the function that's repeatedly applied

    returns

      the iterator producing the infinite sequence of values `start, f(start), f(f(start)), ...`

22. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

25. #### def range(start: Int, end: Int, step: Int): Iterator[Int]

    An iterator producing equally spaced values in some integer interval.

    An iterator producing equally spaced values in some integer interval.

    start

      the start value of the iterator

    end

      the end value of the iterator (the first value NOT returned)

    step

      the increment value of the iterator (must be positive or negative)

    returns

      the iterator producing values `start, start + step, ...` up to, but excluding `end`

26. #### def range(start: Int, end: Int): Iterator[Int]

    Creates nn iterator returning successive values in some integer interval.

    Creates nn iterator returning successive values in some integer interval.

    start

      the start value of the iterator

    end

      the end value of the iterator (the first value NOT returned)

    returns

      the iterator producing values `start, start + 1, ..., end - 1`

27. #### def single[A](elem: A): Iterator[A]

    Creates an iterator which produces a single element.

    Creates an iterator which produces a single element. Note: Equivalent, but more efficient than Iterator(elem)

    elem

      the element

    returns

      An iterator which produces `elem` on the first call to `next`, and which has no further elements.

28. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

29. #### def tabulate[A](end: Int)(f: (Int) ⇒ A): Iterator[A]

    Creates an iterator producing the values of a given function over a range of integer values starting from 0.

    Creates an iterator producing the values of a given function over a range of integer values starting from 0.

    end

      The number of elements returned by the iterator

    f

      The function computing element values

    returns

      An iterator that produces the values `f(0), ..., f(n -1)`.

30. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

31. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

32. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

33. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

### Inherited from AnyRef

### Inherited from Any

### Ungrouped